Attribute VB_Name = "modMain"
Option Explicit

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)


Public Running As Boolean
Dim ArS() As Single
Dim ArI() As Integer
Public LenMain As Long
Dim Max As Single

Public Sub Work()
  Dim fName As String
  Dim Header(10) As Long
  Dim nf As Integer
  Dim i As Long

  ReDim ArS(LenMain - 1)
  ReDim ArI(LenMain - 1)
  Running = True
  Render
  If Running = False Then Exit Sub
  StoI

  Header(0) = &H46464952
  Header(1) = LenMain * 2 + 36
  Header(2) = &H45564157
  Header(3) = &H20746D66
  Header(4) = 16
  Header(5) = &H10001
  Header(6) = 44100
  Header(7) = 44100 * 2
  Header(8) = &H100002
  Header(9) = &H61746164
  Header(10) = LenMain * 2

  fName = "Gt.wav"
  If Running Then
    nf = FreeFile
    Open fName For Binary As #nf
    Close #nf
    Kill fName
    Open fName For Binary As #nf
      Put #nf, , Header()
      Put #nf, , ArI()
    Close #nf
    Sleep 50
    DoEvents
    Sleep 50
    DoEvents
    RunAudio fName
    DoEvents
    For i = 0 To 59
      If Not Running Then Exit For
      Sleep 50
      DoEvents
    Next i
    Do While Running
      DoEvents
      Sleep 50
      If CheckEnd Then Running = False
    Loop
    DShowStop
    Sleep 50
  End If
End Sub

Private Sub Render()
  Dim i As Long

  Max = 0
  For i = 0 To LenMain - 1
    If (i And 2047) = 0 Then
      Form1.ShapeProgress.Width = Form1.ScaleWidth * (i / LenMain)
      DoEvents
      If Not Running Then Exit Sub
    End If
    ArS(i) = GtTick
    If Max < Abs(ArS(i)) Then Max = Abs(ArS(i))
  Next i
End Sub

Private Sub StoI()
  Dim i As Long
  Dim k As Single

  k = 32767 / Max
  For i = 0 To LenMain - 1
    ArI(i) = ArS(i) * k
  Next i
End Sub
